from email.mime import audio
from ursina import *
from ursina.prefabs.first_person_controller import FirstPersonController
app = Ursina()
# Define a Voxel class.
# By setting the parent to scene and the model to 'cube' it becomes a 3d button.
#sky_texture = load_texture('skybox.png')
blockmodel = 'TEXTURE_AND_MODEL/m.obj'
sky_texture = load_texture('skybox.png')
blocktexture_iron = load_texture('TEXTURE_AND_MODEL/iron.png')
blocktexture_gold = load_texture('TEXTURE_AND_MODEL/gold.png')
blocktexture_sand = load_texture('TEXTURE_AND_MODEL/sand.png')
blocktexture_grass = load_texture('TEXTURE_AND_MODEL/grass.png')
blocktexture_dirt = load_texture('TEXTURE_AND_MODEL/dirt.png')
blocktexture_stone = load_texture('TEXTURE_AND_MODEL/stone.png')
t = blocktexture_grass
model = blockmodel
#b_m = Audio('MoogCity.mp3',loop = True,autoplay = True)
class Voxel(Button):
    def __init__(self, position=(0,0,0),texture = blocktexture_iron,model = blockmodel):
        super().__init__(
            parent = scene,
            position = position,
            model = model,
            origin_y = .5,
            texture = texture,
            color = color.color(0,0,random.uniform(0.9,1)),
            highlight_color = color.light_gray,)
    def input(self,key):
        global t,model
        if key == 'escape':
            quit()
        if key == '1':
            t = blocktexture_grass
            model = blockmodel
        if key == '2':
            t = blocktexture_dirt
            model = blockmodel
        if key == '3':
            t = blocktexture_stone
            model = blockmodel
        if key == '4':
            t = blocktexture_iron
            model = blockmodel
        if key == '5':
            t = blocktexture_gold
            model = blockmodel
        if key == '6':
            t = blocktexture_sand
            model = blockmodel
        if self.hovered:
            if key == 'right mouse down' or key == 'o':
                voxel = Voxel(position=self.position + mouse.normal,texture=t)
            if key == 'left mouse down' or key == 'p':
                destroy(self)

for z in range(0,25):
    for x in range(0,25):
        voxel = Voxel(position=(x,2,z),texture=blocktexture_grass,model=blockmodel)
for z in range(0,25):
    for x in range(0,25):
        voxel = Voxel(position=(x,1,z),texture=blocktexture_dirt,model=blockmodel)
for z in range(0,25):
    for x in range(0,25):
        voxel = Voxel(position=(x,0,z),texture=blocktexture_sand,model=blockmodel)
for z in range(0,25):
    for x in range(0,25):
        voxel = Voxel(position=(x,-1,z),texture=blocktexture_stone,model=blockmodel)

class Sky(Entity):
	def __init__(self):
		super().__init__(
			parent = scene,
			model = 'sphere',
			texture = sky_texture,
			scale = 150,
			double_sided = True)



sky = Sky()
player = FirstPersonController()
app.run()
